/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GatewayCreateData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GatewayCreateData{}

// GatewayCreateData struct for GatewayCreateData
type GatewayCreateData struct {
	ChannelId string `json:"channel_id"`
	Name string `json:"name"`
	Maid string `json:"maid"`
	Type Messenger `json:"type"`
	Provider Provider `json:"provider"`
	AuthKey string `json:"auth_key"`
	AuthSecret string `json:"auth_secret"`
	Namespace *string `json:"namespace,omitempty"`
	ExternalIds *GatewayCreateDataExternalIds `json:"external_ids,omitempty"`
}

// NewGatewayCreateData instantiates a new GatewayCreateData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGatewayCreateData(channelId string, name string, maid string, type_ Messenger, provider Provider, authKey string, authSecret string) *GatewayCreateData {
	this := GatewayCreateData{}
	this.ChannelId = channelId
	this.Name = name
	this.Maid = maid
	this.Type = type_
	this.Provider = provider
	this.AuthKey = authKey
	this.AuthSecret = authSecret
	return &this
}

// NewGatewayCreateDataWithDefaults instantiates a new GatewayCreateData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGatewayCreateDataWithDefaults() *GatewayCreateData {
	this := GatewayCreateData{}
	return &this
}

// GetChannelId returns the ChannelId field value
func (o *GatewayCreateData) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *GatewayCreateData) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *GatewayCreateData) SetChannelId(v string) {
	o.ChannelId = v
}

// GetName returns the Name field value
func (o *GatewayCreateData) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *GatewayCreateData) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *GatewayCreateData) SetName(v string) {
	o.Name = v
}

// GetMaid returns the Maid field value
func (o *GatewayCreateData) GetMaid() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Maid
}

// GetMaidOk returns a tuple with the Maid field value
// and a boolean to check if the value has been set.
func (o *GatewayCreateData) GetMaidOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Maid, true
}

// SetMaid sets field value
func (o *GatewayCreateData) SetMaid(v string) {
	o.Maid = v
}

// GetType returns the Type field value
func (o *GatewayCreateData) GetType() Messenger {
	if o == nil {
		var ret Messenger
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *GatewayCreateData) GetTypeOk() (*Messenger, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *GatewayCreateData) SetType(v Messenger) {
	o.Type = v
}

// GetProvider returns the Provider field value
func (o *GatewayCreateData) GetProvider() Provider {
	if o == nil {
		var ret Provider
		return ret
	}

	return o.Provider
}

// GetProviderOk returns a tuple with the Provider field value
// and a boolean to check if the value has been set.
func (o *GatewayCreateData) GetProviderOk() (*Provider, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Provider, true
}

// SetProvider sets field value
func (o *GatewayCreateData) SetProvider(v Provider) {
	o.Provider = v
}

// GetAuthKey returns the AuthKey field value
func (o *GatewayCreateData) GetAuthKey() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AuthKey
}

// GetAuthKeyOk returns a tuple with the AuthKey field value
// and a boolean to check if the value has been set.
func (o *GatewayCreateData) GetAuthKeyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AuthKey, true
}

// SetAuthKey sets field value
func (o *GatewayCreateData) SetAuthKey(v string) {
	o.AuthKey = v
}

// GetAuthSecret returns the AuthSecret field value
func (o *GatewayCreateData) GetAuthSecret() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AuthSecret
}

// GetAuthSecretOk returns a tuple with the AuthSecret field value
// and a boolean to check if the value has been set.
func (o *GatewayCreateData) GetAuthSecretOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AuthSecret, true
}

// SetAuthSecret sets field value
func (o *GatewayCreateData) SetAuthSecret(v string) {
	o.AuthSecret = v
}

// GetNamespace returns the Namespace field value if set, zero value otherwise.
func (o *GatewayCreateData) GetNamespace() string {
	if o == nil || IsNil(o.Namespace) {
		var ret string
		return ret
	}
	return *o.Namespace
}

// GetNamespaceOk returns a tuple with the Namespace field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayCreateData) GetNamespaceOk() (*string, bool) {
	if o == nil || IsNil(o.Namespace) {
		return nil, false
	}
	return o.Namespace, true
}

// HasNamespace returns a boolean if a field has been set.
func (o *GatewayCreateData) HasNamespace() bool {
	if o != nil && !IsNil(o.Namespace) {
		return true
	}

	return false
}

// SetNamespace gets a reference to the given string and assigns it to the Namespace field.
func (o *GatewayCreateData) SetNamespace(v string) {
	o.Namespace = &v
}

// GetExternalIds returns the ExternalIds field value if set, zero value otherwise.
func (o *GatewayCreateData) GetExternalIds() GatewayCreateDataExternalIds {
	if o == nil || IsNil(o.ExternalIds) {
		var ret GatewayCreateDataExternalIds
		return ret
	}
	return *o.ExternalIds
}

// GetExternalIdsOk returns a tuple with the ExternalIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayCreateData) GetExternalIdsOk() (*GatewayCreateDataExternalIds, bool) {
	if o == nil || IsNil(o.ExternalIds) {
		return nil, false
	}
	return o.ExternalIds, true
}

// HasExternalIds returns a boolean if a field has been set.
func (o *GatewayCreateData) HasExternalIds() bool {
	if o != nil && !IsNil(o.ExternalIds) {
		return true
	}

	return false
}

// SetExternalIds gets a reference to the given GatewayCreateDataExternalIds and assigns it to the ExternalIds field.
func (o *GatewayCreateData) SetExternalIds(v GatewayCreateDataExternalIds) {
	o.ExternalIds = &v
}

func (o GatewayCreateData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GatewayCreateData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["name"] = o.Name
	toSerialize["maid"] = o.Maid
	toSerialize["type"] = o.Type
	toSerialize["provider"] = o.Provider
	toSerialize["auth_key"] = o.AuthKey
	toSerialize["auth_secret"] = o.AuthSecret
	if !IsNil(o.Namespace) {
		toSerialize["namespace"] = o.Namespace
	}
	if !IsNil(o.ExternalIds) {
		toSerialize["external_ids"] = o.ExternalIds
	}
	return toSerialize, nil
}

type NullableGatewayCreateData struct {
	value *GatewayCreateData
	isSet bool
}

func (v NullableGatewayCreateData) Get() *GatewayCreateData {
	return v.value
}

func (v *NullableGatewayCreateData) Set(val *GatewayCreateData) {
	v.value = val
	v.isSet = true
}

func (v NullableGatewayCreateData) IsSet() bool {
	return v.isSet
}

func (v *NullableGatewayCreateData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGatewayCreateData(val *GatewayCreateData) *NullableGatewayCreateData {
	return &NullableGatewayCreateData{value: val, isSet: true}
}

func (v NullableGatewayCreateData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGatewayCreateData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


